<template>
  <div class="q-pa-md">
    <q-btn
      @click="openDialogPromotion = true"
      color="primary"
      label="adauga voucher nou"
      icon="add"
    />
    <q-table
      grid
      title="Vouchere"
      @selection="activateVoucher()"
      :data="vouchers"
      :selected.sync="selected"
      selection="multiple"
      :columns="columns"
      row-key="id"
      :filter="filter"
      hide-header
      class="q-mt-lg"
    >
      <template v-slot:top-right>
        <q-input borderless dense debounce="300" v-model="filter" placeholder="Search">
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>
      <template v-slot:item="props">
        <div
          class="q-pa-xs col-xs-12 col-sm-6 col-md-4 col-lg-3 grid-style-transition"
          :style="props.selected ? 'transform: scale(0.95);' : ''"
        >
          <q-card :class="props.selected ? 'bg-grey-2' : ''">
            <q-card-section>
              <q-checkbox dense v-model="props.selected" :label="props.row.name" />
            </q-card-section>
            <q-separator />
            <q-list dense>
              <q-item v-for="col in props.cols.filter(col => col.name !== 'desc')" :key="col.name">
                <q-item-section>
                  <q-item-label caption>{{ col.label }}</q-item-label>
                </q-item-section>
                <q-item-section side>
                  <q-item-label class="text-black">{{ col.value }}</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>
      </template>
    </q-table>

    <q-dialog v-model="openDialogPromotion">
      <q-card style="width: 700px; max-width: 80vw;">
        <q-card-section>
          <p class="text-caption">Alege cate vouchere vrei sa creezi (max. 6) cifre</p>
          <q-input mask="######" outlined v-model="newVoucher.limit" :rules="rules" dense />
          <p class="q-mb-sm q-mt-md text-caption">Alege tipul promotiei</p>
          <q-select dense outlined v-model="newVoucher.type" :options="promotionType" />
          <p class="q-mb-sm q-mt-md text-caption">Alege valoarea voucherului (max. 3) cifre</p>
          <q-input mask="###" outlined v-model="newVoucher.value" :rules="rules" dense />

          <p
            class="q-mb-sm q-mt-md text-caption"
          >*Codul de pe voucher va fi valabil pana ce toate voucherele au fost folosite</p>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn @click="addVoucher()" flat color="primary" icon="add_circle" />
          <q-btn
            @click="openDialogPromotion = false; newVoucher.limit, newVoucher.value=0; "
            flat
            color="primary"
            icon="clear"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import { date } from "quasar";

export default {
  name: "promotions",
  data() {
    return {
      filter: "",
      openDialogPromotion: false,
      selected: [],
      newVoucher: {
        limit: 0,
        type: "percent",
        value: 0,
      },
      columns: [
        {
          name: "code",
          label: "Cod voucher",
          field: "code",
          align: "center",
        },
        {
          name: "type",
          label: "Tip voucher",
          field: "type",
          align: "center",
        },
        {
          name: "value",
          label: "Valoare voucher",
          field: "value",
          align: "center",
        },
        {
          name: "limit",
          label: "Nr. vouchere",
          field: "limit",
          align: "center",
        },
      ],
      promotionType: ["discount", "percent"],
      rules: [(val) => !!val || "Field is required"],
    };
  },
  async mounted() {
    setTimeout(() => {
      this.selected = JSON.parse(this.activatedVoucherString.value);
    }, 500);
  },
  computed: {
    vouchers() {
      return this.$store.getters["adminData/getAllVouchers"];
    },
    adminPreferences() {
      return this.$store.getters["adminData/getAdminPreferences"];
    },
    activatedVoucherString() {
      return this.adminPreferences.find(
        (preference) => preference.name === "activatedVouchers"
      );
    },
  },
  methods: {
    activateVoucher() {
      setTimeout(() => {
        this.$axios
          .put("/api/preferences", {
            name: "activatedVouchers",
            value: JSON.stringify(this.selected),
          })
          .then((response) => {
            this.$q.notify({
              message: "Voucherele s-au selectat",
              color: "positive",
            });
            this.$store.dispatch("adminData/loadAdminPreferences");
          })
          .catch((error) => {
            this.$q.notify({
              color: "negative",

              message: error.response.data.message,
              icon: "report_problem",
            });
          });
      }, 500);
    },
    addVoucher() {
      if (this.newVoucher.value == 0 && this.newVoucher.limit == 0)
        this.$q.notify({
          color: "negative",
          message: "Teebuie sa completezi toate campurile",
          icon: "report_problem",
        });
      else {
        this.$axios
          .post("/api/discount/voucher", this.newVoucher)
          .then((response) => {
            this.openDialogPromotion = false;
            this.$q.notify({
              message: "Ai adaugat un voucher nou!",
              color: "positive",
            });
            this.newVoucher.value, (this.newVoucher.limit = 0);
            this.$store.dispatch("adminData/loadVouchers");
          })
          .catch((error) => {
            this.$q.notify({
              color: "negative",

              message: error.response.data.message,
              icon: "report_problem",
            });
          });
      }
    },
  },
};
</script>

<style></style>
